
var DragonCombineItem = cc.Sprite.extend({
    _name:null,
    arrayTips:null,
    arrayCom:null,
    arraySuc:null,
    arrayPos:null,
    
    ctor:function (name) {
        //////////////////////////////
        // 1. super init first
        this._super(combinePath(name, "target"));

        console.log("dragon name is " + name);
        this._name = name;
        this.arrayCom = new Array();
        this.arrayTips = new Array();
        this.arraySuc = [false, false, false, false];
        this.arrayPos = this.getPosArray(this._name);

        this.createComponents();

        return true;
    },
    createComponents:function(){
        for (var n_itor = 0; n_itor < 4; ++n_itor){
            this.arrayCom[n_itor] = new cc.Sprite(combinePath(this._name, (1 + n_itor)));
            this.arrayCom[n_itor].setOpacity(0);
            this.arrayCom[n_itor].setPosition(this.arrayPos[n_itor]);
            this.arrayTips[n_itor] = new cc.Sprite(combinePath(this._name, (1 + n_itor) + "_tips"));
            this.arrayTips[n_itor].setPosition(this.arrayPos[n_itor]);
            this.arrayTips[n_itor].setOpacity(0);

            this.addChild(this.arrayCom[n_itor], 5 + n_itor);
            this.addChild(this.arrayTips[n_itor], 15 + n_itor);
        }
    },
    partPoint:function(index){
        return this.convertToWorldSpace(this.arrayCom[index-1].getPosition());
    },
    getPosArray:function(name){
        switch (name){
            case "bawang": {
                return Config_Combine.bawang.array_pos_com;
            }
            case "fuzhi": {
                return Config_Combine.fuzhi.array_pos_com;
            }
            case "ji": {
                return Config_Combine.ji.array_pos_com;
            }
            case "jia": {
                return Config_Combine.jia.array_pos_com;
            }
            case "jian": {
                return Config_Combine.jian.array_pos_com;
            }
            case "lingdao": {
                return Config_Combine.lingdao.array_pos_com;
            }
            case "sanjiao": {
                return Config_Combine.sanjiao.array_pos_com;
            }
            case "shejing": {
                return Config_Combine.shejing.array_pos_com;
            }
            case "liang": {
                return Config_Combine.liang.array_pos_com;
            }
            case "yi": {
                return Config_Combine.yi.array_pos_com;
            }
            default:
                break;
        }
    },

    setSucPart:function(index){
        this.arraySuc[index - 1] = true;
        this.arrayCom[index - 1].opacity = 255;
        this.arrayTips[index - 1].opacity = 0;
    },
    restorePart:function(index){
        this.arraySuc[index - 1] = false;
        this.arrayTips[index - 1].stopAllActions();
        this.arrayTips[index - 1].opacity = 0;
    },
    showTips:function (index) {
        if (!this.arraySuc[index - 1]) {
            this.arrayTips[index - 1].runAction(cc.fadeIn(0.15));
        }
    },
    allSuc:function () {
        return this.arraySuc[0] &&  this.arraySuc[1] &&this.arraySuc[2] &&this.arraySuc[3];
    }
});

