
var HomeLayer = cc.Layer.extend({
    menu_figure:null,
    menu_combine:null,
    _adview:null,
    layer_quit:null,
    index:0,
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();

        /////////////////////////////
        // 2. add a menu item with "X" image, which is clicked to quit the program
        //    you may modify it.
        // ask the window size
        var size = cc.winSize;

        this.createComponents();

        this.addBackKeyListener();

        this.getAdList(function () {
            cc.log("ad enable is " + AD_ENABLE + "-----" + "size is " + ARRY_AD_HOME.length);
            if (AD_ENABLE && ARRY_AD_HOME.length != 0) {
                this._adview = new AdViewLayer(ARRY_AD_HOME, cc.size(180 + 2 * gapX()));
                this.addChild(this._adview, 230);
            }

            showBannerAd(BANNER_ENABLE, 0.2, 0);
        }.bind(this));

        return true;
    },

    createComponents:function () {
        var size = cc.winSize;

        var scale = size.height == 1001 ? 1 : 0.8;

        var background = new cc.Sprite(resPath("home", "background"));
        background.setAnchorPoint(cc.p(0, 0));
        background.setPosition(cc.p(0, 0));
        background.scaleX = winWidth() / 1334;
        this.addChild(background, 1);

        var title = new cc.Sprite(resPath("home", "title"));
        title.setPosition(Config_Home.pos_title.begin);
        this.addChild(title, 2);
        title.runAction(cc.sequence(
            cc.moveTo(0.5, Config_Home.pos_title.end).easing(cc.easeSineInOut()),
            cc.scaleTo(0.1, 1.2),
            cc.scaleTo(0.2, 0.8),
            cc.scaleTo(0.1, 1)
        ));

        var btn_privacy = new ccui.Button(resPath("home", "privacy"),resPath("home", "privacy"));
        btn_privacy.setPosition(cc.p(cc.winSize.width - 120, cc.winSize.height - 70));
        btn_privacy.addTouchEventListener(this.btnTouchEvent, this);
        this.addChild(btn_privacy, 3);

        var btn_feed = new ccui.Button(resPath("home", "feed"),resPath("home", "feed"));
        btn_feed.setPosition(cc.p(cc.winSize.width - 350, cc.winSize.height - 70));
        btn_feed.addTouchEventListener(this.feedTouchEvent, this);
        this.addChild(btn_feed, 4);

        this.addMenu();
    },
    addMenu: function () {
        var array_menu_item = new Array();
        var size = cc.winSize;

        this.menu_figure = new cc.MenuItemImage(
            resPath("home", "figure"),
            resPath("home", "figure"),
            function () {
                cc.director.pushScene(new FigureScene());
            }, this);
        this.menu_figure.attr({
            x: Config_Home.array_pos_entry[0].x,
            y: pAdd(Config_Home.array_pos_entry[0], cc.p(0, size.height)).y,
            anchorX: 0.5,
            anchorY: 0.5
        });
        array_menu_item[0] = this.menu_figure;

        this.menu_combine = new cc.MenuItemImage(
            resPath("home", "combine"),
            resPath("home", "combine"),
            function () {
                cc.director.pushScene(new SelectScene());
            }, this);
        this.menu_combine.attr({
            x: Config_Home.array_pos_entry[1].x,
            y: pAdd(Config_Home.array_pos_entry[1], cc.p(0, size.height)).y,
            anchorX: 0.5,
            anchorY: 0.5
        });
        array_menu_item[1] = this.menu_combine;


        var menu = new cc.Menu(array_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 300);

        this.menu_figure.runAction(cc.moveTo(0.5, Config_Home.array_pos_entry[0]));
        this.menu_combine.runAction(cc.sequence(
            cc.delayTime(0.5),
            cc.moveTo(0.5, Config_Home.array_pos_entry[1]),
            cc.callFunc(function () {
                this.showMenuAction();
            }.bind(this))
        ));
    },
    showMenuAction:function(){
        if(this.index == 0){
            this.menu_figure.runAction(cc.sequence(
                cc.scaleTo(0.1, 1.2),
                cc.scaleTo(0.2, 0.8),
                cc.scaleTo(0.1, 1),
                cc.delayTime(2),
                cc.callFunc(function () {
                    this.index = (this.index + 1) % 2;
                    this.showMenuAction();
                }.bind(this))
            ));
        }else if(1 == this.index){
            this.menu_combine.runAction(cc.sequence(
                cc.scaleTo(0.1, 1.2),
                cc.scaleTo(0.2, 0.8),
                cc.scaleTo(0.1, 1),
                cc.delayTime(2),
                cc.callFunc(function () {
                    this.index = (this.index + 1) % 2;
                    this.showMenuAction();
                }.bind(this))
            ));
        }
    },
    btnTouchEvent:function(sender, type){
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                break;

            case ccui.Widget.TOUCH_MOVED:
                break;

            case ccui.Widget.TOUCH_ENDED:
                showPrivacy();
                break;

            case ccui.Widget.TOUCH_CANCELED:
                break;

            default:
                break;
        }
    },
    feedTouchEvent:function(sender, type){
            switch (type) {
                case ccui.Widget.TOUCH_BEGAN:
                    break;

                case ccui.Widget.TOUCH_MOVED:
                    break;

                case ccui.Widget.TOUCH_ENDED:
                    showFeed();
                    break;

                case ccui.Widget.TOUCH_CANCELED:
                    break;

                default:
                    break;
            }
        },
    onEnter:function(){
        this._super();
    },
    onExitTransitionDidStart:function(){
        this._super();
        // stopAllAudios();
    },
    addBackKeyListener:function(){
        var self = this;
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
         	onKeyReleased: function(keyCode, event) {
         		if (keyCode == cc.KEY.back) {
                    if (self.layer_quit) {
                        self.layer_quit.removeFromParent(true);
                        self.layer_quit = null;
                    } else {
                        var ad_item = getQuitAd();

                        self.layer_quit = new QuitAdViewLayer(function(action) {
                            switch (action) {
                                case "quit":
                                    {
                                        stopAllAudios();
                                        cc.director.end();
                                        break;
                                    }
                                    case "continue":
                                    {
                                        self.layer_quit.removeFromParent(true);
                                        self.layer_quit = null;
                                        break;
                                    }
                                    default:
                                        break;
                                }
                            }, ad_item);

                        self.addChild(self.layer_quit, 550);
                    }
         		}
        }}, this);
    },
    getAdList:function (showAd) {
        getAdConfig("http://www.qinqinxiong.com/project/qqxmgr/admgr.php?pkg=" + getPackage() + "&channel=" + getChannel() + "&ver=" + verCode(),
            function(){
                cc.log("request finish!!!");
                var ad_value = cc.sys.localStorage.getItem(KEY_AD_LIST);
                console.log(ad_value);
                if (ad_value){
                    var parse_result = JSON.parse(ad_value);
                    AD_ENABLE = parse_result.enable;
                    var ad_home = parse_result.homead;
                    var ad_in = parse_result.inad;
                    var ad_quit = parse_result.quitad;

                    if (null != ad_home){
                        var ad_home_list = new Array(ad_home.length);
                        parseAdList(ad_home_list, ad_home);
                        ARRY_AD_HOME = filterAdInstall(ad_home_list, 4);
                    }

                    if (null != ad_in){
                        var ad_in_list = new Array(ad_in.length);
                        parseAdList(ad_in_list, ad_in);
                        ARRY_AD_IN = filterAdInstall(ad_in_list, 4);
                    }

                    if (null != ad_quit){
                        var ad_quit_list = new Array(ad_quit.length);
                        parseAdList(ad_quit_list, ad_quit);
                        ARRY_AD_QUIT = filterAdInstall(ad_quit_list, 4);
                    }

                    SPLASH_ENABLE = parse_result.bd_splash;
                    BANNER_ENABLE = parse_result.bd_banner;

                    setSplashEnable(SPLASH_ENABLE);

                    showAd();
                }
            });

    }
});

var HomeScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        CB_CALLED = false;
        cc.audioEngine.playMusic("res/sound/bga.mp3", true);
        var layer = new HomeLayer();
        this.addChild(layer);
    }
});

