
var SelectLayer = cc.Layer.extend({
    dragon_tar:null,
    array_dragon:null,
    array_listeners:null,
    index:0,
    labelName:null,
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();

        /////////////////////////////
        // 2. add a menu item with "X" image, which is clicked to quit the program
        //    you may modify it.
        // ask the window size
        var size = cc.winSize;

        this.array_dragon = [null, null, null, null, null, null, null, null, null, null];
        this.array_listeners = [null, null, null, null, null, null, null, null, null, null];

        this.createComponents();

        addBackMenu(this.menu, this, function(){
            cc.director.popScene();
        });

        addClearMenu(this.menu_clear, this, function () {
            console.log("clear clicked!!!!");
            this.clearDragons();
            this.refreshDragons();
        }.bind(this));

        this.addListeners();

        return true;
    },

    clearDragons:function(){
        for (var n_itor = 0; n_itor < Config_Common.array_dinosaurs.length; ++n_itor){
            cc.sys.localStorage.setItem(Config_Common.array_dinosaurs[n_itor].did, 0);
        }
    },
    createComponents:function () {
        var size = cc.winSize;

        var background = new cc.Sprite(resPath("select", "background"));
        background.setAnchorPoint(cc.p(0, 0));
        background.setPosition(cc.p(0, 0));
        background.scaleX = winWidth() / 1334;
        this.addChild(background, 1);

        for (var n_itor = 0; n_itor < 10; ++n_itor){
            var name = Config_Select.array_dragon[n_itor].name;
            this.array_dragon[n_itor] = new DragonSelItem(name, false);
            this.array_dragon[n_itor].scale = Config_Select.array_dragon[n_itor].scale;
            this.array_dragon[n_itor].rotationY = Config_Select.array_dragon[n_itor].rotX;
            this.array_dragon[n_itor].setPosition(Config_Select.array_dragon[n_itor].pos);
            this.array_dragon[n_itor].opacity = 0;
            this.addChild(this.array_dragon[n_itor], 10 + n_itor);
        }
    },
    refreshDragons:function(){
        for (var n_itor = 0; n_itor < 10; ++n_itor){
            var name = Config_Select.array_dragon[n_itor].name;
            var b_sel = cc.sys.localStorage.getItem(name);
            if (b_sel && (1 == b_sel)) {
                this.array_dragon[n_itor].setSelect(true);
            }else {
                this.array_dragon[n_itor].setSelect(false);
            }

            this.array_dragon[n_itor].runAction(cc.fadeIn(0.3));
        }
    },
    onEnter:function(){
        this._super();
        this.refreshDragons();
    },
    addListeners:function(){
        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return true;
                }

                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();
                self.checkTarget(target);
            },
            onTouchCanceled: function (touch, event) {
            }
        });

        for (var n_itor = 0; n_itor < this.array_dragon.length; ++n_itor){
            cc.eventManager.addListener(sprite_listener.clone(), this.array_dragon[n_itor]);
        }
    },
    checkTarget:function(target){
        console.log("dragon is " + target.getName());
        cc.director.pushScene(new CombineScene(this.dragonIndex(target.getName())));
    },
    dragonIndex:function(name){
        switch (name){
            case "bawang":
                return 0;
            case "fuzhi":
                return 1;
            case "ji":
                return 2;
            case "jia":
                return 3;
            case "jian":
                return 4;
            case "liang":
                return 5;
            case "lingdao":
                return 6;
            case "sanjiao":
                return 7;
            case "shejing":
                return 8;
            case "yi":
                return 9;
            default:
                return 0;
        }
    },
    cleanup:function () {
        this._super();
    }
});

var SelectScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        CB_CALLED = false;
        var layer = new SelectLayer();
        this.addChild(layer);
    }
});

